unit vermischtesU;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils; 
FUNCTION finderundezahl(x:double):double;
FUNCTION finderundezeit(x:double):double;
FUNCTION zeitinstring(x:double):string;
FUNCTION finde2potenz(x:integer):integer;
FUNCTION winkel(re,im:double):double;
FUNCTION si(x:double):double;
implementation

FUNCTION finderundezahl(x:double):double;
BEGIN
  IF x<=0.1 THEN result:=finderundezahl(x*10)/10 ELSE
  IF x>1 THEN result:=finderundezahl(x/10)*10 ELSE
  IF x>0.75 THEN result:=1 ELSE
  IF x>0.3 THEN result:=0.5 ELSE
  IF x>0.21 THEN result:=0.25 ELSE
  IF x>0.15 THEN result:=0.2 ELSE
    result:=0.1;
end;

FUNCTION finderundezeit(x:double):double;
BEGIN
  IF x>2000 THEN result:=finderundezahl(x/3600)*3600 ELSE
  IF x>40 THEN result:=finderundezahl(x/60)*60 ELSE
    result:=finderundezahl(x);
end;

FUNCTION zeitinstring(x:double):string;
VAR std,min:integer;
    sek:double;
    s:string;
BEGIN
  min:=round(int(x/60));
  std:=min DIV 60;
  min:=min MOD 60;
  sek:=x-3600*std-60*min;
  s:='';
  IF std<>0 THEN s:=s+inttostr(std)+'h ';
  IF min<>0 THEN s:=s+inttostr(min)+'m ';
  s:=s+floattostr(sek)+'s';
  result:=s;
END;

FUNCTION finde2potenz(x:integer):integer;
BEGIN
  IF x>1 THEN result:=finde2potenz(x div 2)*2
         ELSE result:=1;
end;

FUNCTION winkel(re,im:double):double;
BEGIN
  IF im<0 THEN result:=-winkel(re,-im) ELSE
  IF re<0 THEN result:=pi-winkel(-re,im) ELSE
  IF re>im THEN result:=arctan(im/re) ELSE
                result:=pi/2-arctan(re/im);
end;


FUNCTION si(x:double):double;
BEGIN
  IF x=0 THEN result:=1 ELSE result:=sin(x)/x;
end;

end.

